> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.shipbob.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.shipbob.com/_mcp/server.

# Add a single product to the store


POST https://api.shipbob.com/1.0/product
Content-Type: application/json

Reference: https://developer.shipbob.com/v1.0/api/products/add-a-single-product-to-the-store

## Authentication

- `Authorization` header (bearer token, required) — Authentication using Personal Access Token (PAT) token
- `Authorization` header (bearer token, required) — OAuth2 authentication using JWT tokens

## Servers

- `https://api.shipbob.com` (https://api.shipbob.com, default)
- `https://sandbox-api.shipbob.com` (https://sandbox-api.shipbob.com)

## Request

### Headers

- `shipbob_channel_id` (string, required) — Channel Id for Operation

### Body (application/json)

- `name` (string, required) — The name of the product
- `reference_id` (string, required) — Unique reference identifier for the product. Any linked or generated inventory will also be uniquely identified by this value
- `barcode` (string, optional, nullable) — Barcode for the product
- `gtin` (string, optional, nullable) — Global Trade Item Number - unique and internationally recognized identifier assigned to item by company GS1.
- `sku` (string, optional, nullable) — Stock keeping unit for the product
- `unit_price` (double, optional, nullable) — The price of one unit
- `upc` (string, optional, nullable) — Universal Product Code - Unique external identifier

## Response

### 200

Success

- `barcode` (string, optional, nullable) — Barcode for the product
- `bundle_root_information` (object, optional)
  - `id` (integer, optional) — Id of the bundle root product
  - `name` (string, optional, nullable) — Name of the bundle root product
- `channel` (object, optional) — Information about a store channel
  - `id` (integer, optional) — Unique id of the store channel
  - `name` (string, optional, nullable) — Name of the store channel
- `created_date` (datetime, optional) — Date the product was created
- `fulfillable_inventory_items` (list of object, optional, nullable) — The inventory that this product will resolve to when packing a shipment
  - `id` (integer, optional) — Unique id of the inventory item
  - `name` (string, optional, nullable) — Name of the inventory item
  - `quantity` (integer, optional) — Quantity of the inventory item included in a store product
- `fulfillable_quantity_by_fulfillment_center` (list of object, optional, nullable) — Fulfillable quantity of this product broken down by fulfillment center location
  - `committed_quantity` (integer, optional) — Amount of committed quantity at this fulfillment center
  - `fulfillable_quantity` (integer, optional) — Amount of fulfillable quantity at this fulfillment center
  - `id` (integer, optional) — Unique id of the fulfillment center
  - `name` (string, optional, nullable) — Name of the fulfillment center
  - `onhand_quantity` (integer, optional) — Amount of onhand quantity at this fulfillment center
- `gtin` (string, optional, nullable) — Global Trade Item Number - unique and internationally recognized identifier assigned to item by company GS1.
- `id` (integer, optional) — Unique identifier of the product
- `name` (string, optional, nullable) — The name of the product
- `reference_id` (string, optional, nullable) — Unique reference identifier of the product
- `sku` (string, optional, nullable) — Stock keeping unit for the product
- `total_committed_quantity` (integer, optional) — Total committed quantity of this product
- `total_fulfillable_quantity` (integer, optional) — Total fulfillable quantity of this product
- `total_onhand_quantity` (integer, optional) — Total on hand quantity of this product
- `unit_price` (double, optional, nullable) — The price of one unit
- `upc` (string, optional, nullable) — Universal Product Code - Unique external identifier

## Examples

**Request**

```json
{
  "name": "Medium Blue T-Shirt",
  "reference_id": "TShirtBlueM",
  "barcode": "123456789012",
  "gtin": "012345678905",
  "sku": "TShirtBlueM",
  "unit_price": 20.32,
  "upc": "012345678912"
}
```

**Response**

```json
{
  "barcode": "123456789012",
  "bundle_root_information": {
    "id": 0,
    "name": "string"
  },
  "channel": {
    "id": 0,
    "name": "House of Slippers"
  },
  "created_date": "2019-08-24T14:15:22Z",
  "fulfillable_inventory_items": [
    {
      "id": 0,
      "name": "Medium Blue T-Shirt",
      "quantity": 0
    }
  ],
  "fulfillable_quantity_by_fulfillment_center": [
    {
      "committed_quantity": 0,
      "fulfillable_quantity": 0,
      "id": 0,
      "name": "Cicero",
      "onhand_quantity": 0
    }
  ],
  "gtin": "012345678905",
  "id": 0,
  "name": "Medium Blue T-Shirt",
  "reference_id": "TShirtBlueM",
  "sku": "TShirtBlueM",
  "total_committed_quantity": 0,
  "total_fulfillable_quantity": 0,
  "total_onhand_quantity": 0,
  "unit_price": 20.32,
  "upc": "012345678912"
}
```

**SDK Code**

```python Products_addASingleProductToTheStore_example
import requests

url = "https://api.shipbob.com/1.0/product"

payload = {
    "name": "Medium Blue T-Shirt",
    "reference_id": "TShirtBlueM",
    "barcode": "123456789012",
    "gtin": "012345678905",
    "sku": "TShirtBlueM",
    "unit_price": 20.32,
    "upc": "012345678912"
}
headers = {
    "shipbob_channel_id": "shipbob_channel_id",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Products_addASingleProductToTheStore_example
const url = 'https://api.shipbob.com/1.0/product';
const options = {
  method: 'POST',
  headers: {
    shipbob_channel_id: 'shipbob_channel_id',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: '{"name":"Medium Blue T-Shirt","reference_id":"TShirtBlueM","barcode":"123456789012","gtin":"012345678905","sku":"TShirtBlueM","unit_price":20.32,"upc":"012345678912"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Products_addASingleProductToTheStore_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.shipbob.com/1.0/product"

	payload := strings.NewReader("{\n  \"name\": \"Medium Blue T-Shirt\",\n  \"reference_id\": \"TShirtBlueM\",\n  \"barcode\": \"123456789012\",\n  \"gtin\": \"012345678905\",\n  \"sku\": \"TShirtBlueM\",\n  \"unit_price\": 20.32,\n  \"upc\": \"012345678912\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("shipbob_channel_id", "shipbob_channel_id")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Products_addASingleProductToTheStore_example
require 'uri'
require 'net/http'

url = URI("https://api.shipbob.com/1.0/product")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["shipbob_channel_id"] = 'shipbob_channel_id'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Medium Blue T-Shirt\",\n  \"reference_id\": \"TShirtBlueM\",\n  \"barcode\": \"123456789012\",\n  \"gtin\": \"012345678905\",\n  \"sku\": \"TShirtBlueM\",\n  \"unit_price\": 20.32,\n  \"upc\": \"012345678912\"\n}"

response = http.request(request)
puts response.read_body
```

```java Products_addASingleProductToTheStore_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.shipbob.com/1.0/product")
  .header("shipbob_channel_id", "shipbob_channel_id")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Medium Blue T-Shirt\",\n  \"reference_id\": \"TShirtBlueM\",\n  \"barcode\": \"123456789012\",\n  \"gtin\": \"012345678905\",\n  \"sku\": \"TShirtBlueM\",\n  \"unit_price\": 20.32,\n  \"upc\": \"012345678912\"\n}")
  .asString();
```

```php Products_addASingleProductToTheStore_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.shipbob.com/1.0/product', [
  'body' => '{
  "name": "Medium Blue T-Shirt",
  "reference_id": "TShirtBlueM",
  "barcode": "123456789012",
  "gtin": "012345678905",
  "sku": "TShirtBlueM",
  "unit_price": 20.32,
  "upc": "012345678912"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
    'shipbob_channel_id' => 'shipbob_channel_id',
  ],
]);

echo $response->getBody();
```

```csharp Products_addASingleProductToTheStore_example
using RestSharp;

var client = new RestClient("https://api.shipbob.com/1.0/product");
var request = new RestRequest(Method.POST);
request.AddHeader("shipbob_channel_id", "shipbob_channel_id");
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Medium Blue T-Shirt\",\n  \"reference_id\": \"TShirtBlueM\",\n  \"barcode\": \"123456789012\",\n  \"gtin\": \"012345678905\",\n  \"sku\": \"TShirtBlueM\",\n  \"unit_price\": 20.32,\n  \"upc\": \"012345678912\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Products_addASingleProductToTheStore_example
import Foundation

let headers = [
  "shipbob_channel_id": "shipbob_channel_id",
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "Medium Blue T-Shirt",
  "reference_id": "TShirtBlueM",
  "barcode": "123456789012",
  "gtin": "012345678905",
  "sku": "TShirtBlueM",
  "unit_price": 20.32,
  "upc": "012345678912"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.shipbob.com/1.0/product")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```